#ifndef UCD_HUAPING_H
#define UCD_HUAPING_H
#pragma once
#include <PSolid\PSolidCoreAPI.h>
#include <Mstn\PSolid\mssolid.h>
#include <Mstn\PSolid\mssolid.fdf>
#include <Mstn\MdlApi\msbrepcommon.r.h>
#include <vector>
#include <math.h> 
#include "UI_Pub_JiaoHu.h"
#include "UI_Pub_JiaoHu.h"
#include "UCD_DianShi.h"
#include "UCD_KouCao.h"
#include "UCD_Piers.h"
#include "UCD_CAPS.h"
#include "UCD_Piles.h"
//#include "..\DFCFCreateXml.h"
#include "UCD_CellPub.h"

USING_NAMESPACE_BENTLEY_DGNPLATFORM
USING_NAMESPACE_BENTLEY_MSTNPLATFORM
USING_NAMESPACE_BENTLEY_MSTNPLATFORM_ELEMENT
using  namespace std;
//************************************************ 
//      : UCD_HuaPing.h
//    : ƿյĶʵֲ
//				Ҫṹƿƿ棩+֣ҸҪǷҪ۲ۣǲǴлƿնνṹ(Zϵ»ΪtopΡbottom)
//              ԶĵΪοԭ㡣ģеĳߴϢǷֱʣ漰ֱʵ⣬ҪڽеĲתɶӦֱµĳߴϢ
//              ɵʵС Ҫ1km*1km*1km,ϵͳ
//              λΪ    
//    : 20200615                   
//        : zxl            
//  ޸ļ¼  : 
//*************************************************
class UCD_HuaPing{

public:
	
	//***************************************************
	//      UCD_BSGL
	//    캯
	//   ֵ   	
	//**************************************************** 
	UCD_HuaPing(const double TotalZLen , const double TopR_Xlen , const double TopR_Ylen ,  const double TopR_Zlen , const double BT_R_Xlen , const double BT_R_Ylen   )
	{
		this->TotalZLen     =TotalZLen;
		TopRectXLen   =TopR_Xlen;
		TopRectYLen   =TopR_Ylen;
		TopRectZlen   =TopR_Zlen;
		BT_Rect_XLen  =BT_R_Xlen;
		BT_Rect_YLen  =BT_R_Ylen;
		nArcFlag=-1;
		nKCFlag=-1;
		nKC=-1;
		H2=0.0;
		
	}
	
	//***************************************************
	//      ~UCD_HuaPing
	//    
	//   ֵ   	
	//**************************************************** 
	~UCD_HuaPing()
	{
		
	}
	//***************************************************
	//      SetArcHight
	//    ûƿյĻĸ߶ȣҲ棩
	//   һArcZlen ƿ໡ĸ߶ȡ
	//   ֵ   ɹ0򷵻ط0.	
	//**************************************************** 
	int SetArcHight(const double ArcZlen)
	{
		if(ArcZlen < 1)
		  return -1;
	    HuZLen=ArcZlen;
		HuR = (0.25*(TopRectXLen - BT_Rect_XLen)*(TopRectXLen - BT_Rect_XLen) + HuZLen*HuZLen) / (TopRectXLen - BT_Rect_XLen);
		BT_Rect_ZLen  =TotalZLen-HuZLen- TopRectZlen;
		if(BT_Rect_ZLen < 10)
			return -2;
		nArcFlag=0;
		   return 0;
	}
	//***************************************************
	//      SetArcRadius
	//    ûƿڻİ뾶ûĴֱ߶ȡ
	//   һArcRadius  ƿ໡İ뾶ȡ
	//   ֵ   ɹ0򷵻ط0.	
	//**************************************************** 
	int SetArcRadius(const double ArcRadius)
	{
		if(ArcRadius < 1)
		  return -1;
	    HuR=ArcRadius;
		nArcFlag=1;
		HuZLen=TopRectZlen+sqrt(ArcRadius*(TopRectXLen - BT_Rect_XLen) - 0.25*(TopRectXLen - BT_Rect_XLen)*(TopRectXLen - BT_Rect_XLen) );
		BT_Rect_ZLen  =TotalZLen-HuZLen- TopRectZlen;
		if(BT_Rect_ZLen < 10)
			return -2;
		  return 0;
	}
	
	//***************************************************
	//      SetKC_Info
	//    ûƿϵĿ۲Ϣ
	//   һKCT_XLen  ۲۶Xĳȡ
	//   KCB_Xlen  ۲۵ײXĳȡ
	//   KCDeepY   ۲ƽϵȣYĳȡ
	//   ģKCHuZlen  ۲Zĳ  뾶
	//   ģnFlag     0 KCHuZlen Ϊȣ1뾶
	//   ֵ   ɹ0򷵻ط0.	
	//**************************************************** 
	int SetKC_Info(const double KCT_XLen , const double KCB_Xlen , const double KCDeepY , const double KCHuZlen ,int nFlag)
	{
		if(KCT_XLen < 1)
			return -1;
		if(KCB_Xlen < 1)
			return -2;
		if(KCDeepY < 1)
			return -3;
		if(KCHuZlen < 1)
			return -4;
		this->kouCaoT_XLen=KCT_XLen;
		this->KouCaoB_Xlen=KCB_Xlen;
		this->KouCaoDeepY=KCDeepY;
		if(nFlag==0)//ݻĸ߶ Ļ뾶
		{
			this->KC_R=(0.25*(KCT_XLen - KCB_Xlen)*(KCT_XLen - KCB_Xlen) + KCHuZlen*KCHuZlen) / (KCT_XLen - KCB_Xlen);//İ뾶
			this->KouCaoHuZlen=KCHuZlen;//ĸ߶
			nKC=0;
		}
		else if(nFlag==1)//ݻİ뾶 㻡ĸ߶ȡ
		{   //ĸ߶
			this->KouCaoHuZlen=TopRectZlen+sqrt(KCHuZlen*(KCT_XLen - KCB_Xlen) - 0.25*(KCT_XLen - KCB_Xlen)*(KCT_XLen - KCB_Xlen) );
			this->KC_R=KCHuZlen;//İ뾶
			nKC=1;
		}
		return 0;
	}
	
	//***************************************************
	//      SetKC_Switch
	//    ûƿտ۲ǷĿء
	//   һFlag  trueǿ۲ۡfalse  رտ۲ۡ
	//   ֵ   ɹ0򷵻ط0.	
	//**************************************************** 
	int SetKC_Switch(bool Flag)
	{
		if(Flag == true)
		{
			nKCFlag=1;//۲
		}
		else if(Flag == false )
		{
			nKCFlag=0;//رտ۲
		}
		return 0;
	}
	
	//***************************************************
	//      CreateHuaPing3D
	//    һά۲۵ĻƿǶղﴴ
	//   һeeh  		ƿյľ
	//   һbasePt  	οҲǻƿնεĵ㡣
	//   ֵ   ɹ0򷵻ط0.	
	//**************************************************** 
	int CreateHuaPing3D(EditElementHandle &eeh , DPoint3dCR basePt )
	{
		if(nArcFlag < 0 )
			return -1;
		if(nKC < 0 )
			return -2;
		if(BT_Rect_ZLen < KouCaoHuZlen )
		{
			WarningMessageBox(L"ڲ໡߶  ײθ߶Ȳһ");
			return -3;
		}
		Prepare_Data( basePt);//׼
		//һһ3DԲԲԲڶԻƿսи Ӷγɻƿ
		DPoint3d         pts3_1[2];//ƻߵ
		pts3_1[0]=pts11[0];//
		pts3_1[1].x=pts22[0].x;pts3_1[1].y=pts11[0].y;pts3_1[1].z=pts11[0].z-HuZLen;//յ
		//ûԲĵ㣬Ӧǽpts3_1[1] ƶһ뾶λãΪpts3_1[1]Բееλá
		DPoint3d CirPos;
		CirPos.x=pts3_1[1].x-HuR;CirPos.y=pts3_1[1].y;CirPos.z=pts3_1[1].z;
		CurveVectorPtr cylinder1 = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
		DEllipse3d arcPts0;
		arcPts0.InitFromCenterMajorAxisPointAndThirdPoint(CirPos, pts3_1[0], pts3_1[1]);//Բյ㴴Բ
		cylinder1->Add(ICurvePrimitive::CreateArc(arcPts0));	
		
		EditElementHandle eehcylinder1;
		DVec3d extrusionVec0 = DVec3d::From(0, TopRectYLen, 0 );
		DgnExtrusionDetail  data0(cylinder1, extrusionVec0, true);//pCurveVec 
		ISolidPrimitivePtr pSolid0 = ISolidPrimitive::CreateDgnExtrusion(data0);	
		DraftingElementSchema::ToElement(eehcylinder1, *pSolid0, nullptr, *ACTIVEMODEL);
		
		//ڶڶɻɵԲڶԻƿսиӶγɻƿ档
		pts3_1[0]=pts11[1];//
		pts3_1[1].x=pts22[1].x;pts3_1[1].y=pts11[1].y;pts3_1[1].z=pts11[1].z-HuZLen;//յ
		CirPos.x=pts3_1[1].x+HuR;CirPos.y=pts3_1[1].y;CirPos.z=pts3_1[1].z;
		CurveVectorPtr cylinder2 = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
		DEllipse3d arcPts1;
		arcPts1.InitFromCenterMajorAxisPointAndThirdPoint(CirPos, pts3_1[0], pts3_1[1]);//Բյ㴴Բ
		cylinder2->Add(ICurvePrimitive::CreateArc(arcPts1));
		
		EditElementHandle eehcylinder2;
		DVec3d extrusionVec1 = DVec3d::From(0, TopRectYLen, 0 );
		DgnExtrusionDetail  data1(cylinder2, extrusionVec1, true);//pCurveVec 
		ISolidPrimitivePtr pSolid1 = ISolidPrimitive::CreateDgnExtrusion(data1);	
		DraftingElementSchema::ToElement(eehcylinder2, *pSolid1, nullptr, *ACTIVEMODEL);
		
		// 㼯ϣ Ϊһ塣
		EditElementHandle eehRect;
		CurveVectorPtr pCurveVecR = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
		pCurveVecR->Add(ICurvePrimitive::CreateRectangle(basePt.x-TopRectXLen/2,basePt.y-TopRectYLen/2,basePt.x+TopRectXLen/2,basePt.y+TopRectYLen/2,basePt.z) );
		DVec3d extrusionVec = DVec3d::From(0, 0, -(HuZLen+TopRectZlen) );
		DgnExtrusionDetail  data(pCurveVecR, extrusionVec, true);//pCurveVec 
		ISolidPrimitivePtr pSolid = ISolidPrimitive::CreateDgnExtrusion(data);	
		DraftingElementSchema::ToElement(eehRect, *pSolid, nullptr, *ACTIVEMODEL);
		
		//Ĳһά ʵ壬Ӷ֤YĳԱҪһ£
		         //ͼ иһ ͿԴﵽԤЧǲʩҵҲͼεĵᷢ仯
		         //ǰиҲиΡ//׼һиĸݡ
		EditElementHandle eehQ1;
		CurveVectorPtr pCurveVecq1 = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
		pCurveVecq1->Add(ICurvePrimitive::CreateRectangle(pts1[0].x,pts1[0].y,pts1[1].x,pts22[1].y,pts1[1].z) );
		DVec3d extrusionVecQ1 = DVec3d::From(0, 0, -(HuZLen+TopRectZlen) );
		DgnExtrusionDetail  dataQ1(pCurveVecq1, extrusionVecQ1, true);//pCurveVec 
		ISolidPrimitivePtr pSolidQ1 = ISolidPrimitive::CreateDgnExtrusion(dataQ1);	
		DraftingElementSchema::ToElement(eehQ1, *pSolidQ1, nullptr, *ACTIVEMODEL);
		
		//岽ڶʵ иXZ 档
		EditElementHandle eehQ2;
		CurveVectorPtr pCurveVecq2 = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
		pCurveVecq2->Add(ICurvePrimitive::CreateRectangle(pts1[3].x,pts1[3].y,pts1[2].x,pts22[2].y,pts1[3].z) );
		DVec3d extrusionVecQ2 = DVec3d::From(0, 0, -(HuZLen+TopRectZlen) );
		DgnExtrusionDetail  dataQ2(pCurveVecq2, extrusionVecQ2, true);//pCurveVec 
		ISolidPrimitivePtr pSolidQ2 = ISolidPrimitive::CreateDgnExtrusion(dataQ2);	
		DraftingElementSchema::ToElement(eehQ2, *pSolidQ2, nullptr, *ACTIVEMODEL);
		
		//XZϵ ۲һ   ۲۶
		EditElementHandle kc_eeh1,kc_eeh2;
		if(H2 > 1)//H2 1ʱ˵ ƿһǾο۲ۣȻ  Ϳ۲ۡ
		{}
		else// ˵ο۲ Ӷײûоο۲۵Ĵڡ
		{
			//һֱ 2020-07-09 zxl_add start
			pts3_1[0].x=basePt.x-kouCaoT_XLen/2;pts3_1[0].y=pts2[0].y;pts3_1[0].z=basePt.z;//ֱߵ
			pts3_1[1].x=basePt.x-kouCaoT_XLen/2;pts3_1[1].y=pts2[0].y;pts3_1[1].z=pts11[0].z;//ֱߵյ
			DSegment3d seg2;	
			seg2.Init(pts3_1[0],pts3_1[1] );
			CurveVectorPtr cylinder3 = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
			cylinder3->Add(ICurvePrimitive::CreateLine(seg2) );
			//һֱ 2020-07-09 zxl_add end
			
			pts3_1[0].x=basePt.x-kouCaoT_XLen/2;pts3_1[0].y=pts22[0].y;pts3_1[0].z=pts11[0].z;//
			pts3_1[1].x=basePt.x-KouCaoB_Xlen/2;pts3_1[1].y=pts22[0].y;pts3_1[1].z=pts22[0].z;//յ
			CirPos.x=pts3_1[1].x-KC_R;CirPos.y=pts3_1[1].y;CirPos.z=pts3_1[1].z;
			arcPts1.InitFromCenterMajorAxisPointAndThirdPoint(CirPos, pts3_1[0], pts3_1[1]);//Բյ㴴Բ
			cylinder3->Add(ICurvePrimitive::CreateArc(arcPts1));	//һ
			
			
			pts3_1[0]=pts3_1[1];
			pts3_1[1].x=basePt.x+KouCaoB_Xlen/2;
			seg2.Init(pts3_1[0],pts3_1[1] );
			cylinder3->Add(ICurvePrimitive::CreateLine(seg2) );// һֱ
			
			pts3_1[0].x=basePt.x+KouCaoB_Xlen/2;pts3_1[0].y=pts22[0].y; pts3_1[0].z=pts22[0].z;// 
			pts3_1[1].x=basePt.x+kouCaoT_XLen/2;pts3_1[1].y=pts22[0].y; pts3_1[1].z=pts11[0].z;//յ			
			CirPos.x=pts3_1[0].x+KC_R;CirPos.y=pts3_1[0].y;CirPos.z=pts3_1[0].z;
			arcPts1.InitFromCenterMajorAxisPointAndThirdPoint(CirPos, pts3_1[0], pts3_1[1]);//Բյ㴴Բ
			cylinder3->Add(ICurvePrimitive::CreateArc(arcPts1));	//ڶ
			
			/*
			pts3_1[0]=pts3_1[1];//ֱߵ
			pts3_1[1].x=basePt.x-kouCaoT_XLen/2;pts3_1[1].y=pts2[1].y;pts3_1[1].z=pts11[1].z;//ֱߵյ
			seg2.Init(pts3_1[0],pts3_1[1] );
			cylinder3->Add(ICurvePrimitive::CreateLine(seg2) );// ڶֱ
			
			*///2020-07-09 zxl_add ע
			
			//  ڶֱ  2020-7-09 zxl_add start
			pts3_1[0]=pts3_1[1];//ֱߵ
			pts3_1[1].z=basePt.z;
			seg2.Init(pts3_1[0],pts3_1[1] );
			cylinder3->Add(ICurvePrimitive::CreateLine(seg2) );// ڶֱ
			//  ڶֱ  2020-7-09 zxl_add end
			
			//ĵֱ 2020-07-09 zxl_add start
			pts3_1[0]=pts3_1[1];//ֱߵ
			pts3_1[1].x=basePt.x-kouCaoT_XLen/2;pts3_1[1].y=pts2[0].y;pts3_1[1].z=basePt.z;//ֱߵ
			pts3_1[0].x=basePt.x-kouCaoT_XLen/2;pts3_1[0].y=pts2[0].y;pts3_1[0].z=basePt.z;//ֱߵ
			seg2.Init(pts3_1[0],pts3_1[1] );
			cylinder3->Add(ICurvePrimitive::CreateLine(seg2) );// ڶֱ
			//ĵֱ 2020-07-09 zxl_add end
			
			DVec3d extrusionVec4 = DVec3d::From(0, KouCaoDeepY, 0 );
			DgnExtrusionDetail  data4(cylinder3, extrusionVec4, true);//pCurveVec 
			ISolidPrimitivePtr pSolid4 = ISolidPrimitive::CreateDgnExtrusion(data4);	
			DraftingElementSchema::ToElement(kc_eeh1, *pSolid4, nullptr, *ACTIVEMODEL);
			
			//ڶ۲ʵ
			
			//һֱ 2020-07-09 zxl_add start
			pts3_1[0].x=basePt.x-kouCaoT_XLen/2;pts3_1[0].y=pts2[3].y;pts3_1[0].z=basePt.z;//
			pts3_1[1].x=basePt.x-kouCaoT_XLen/2;pts3_1[1].y=pts2[3].y;pts3_1[1].z=pts11[3].z;//
			seg2.Init(pts3_1[0],pts3_1[1] );
			CurveVectorPtr cylinder4 = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
			cylinder4->Add(ICurvePrimitive::CreateLine(seg2) );
			//һֱ 2020-07-09 zxl_add end
			
			pts3_1[0].x=basePt.x-kouCaoT_XLen/2;pts3_1[0].y=pts2[3].y;pts3_1[0].z=pts11[3].z;//
			pts3_1[1].x=basePt.x-KouCaoB_Xlen/2;pts3_1[1].y=pts22[3].y;pts3_1[1].z=pts22[3].z;//յ
			CirPos.x=pts3_1[1].x-KC_R;CirPos.y=pts3_1[1].y;CirPos.z=pts3_1[1].z;
			arcPts1.InitFromCenterMajorAxisPointAndThirdPoint(CirPos, pts3_1[0], pts3_1[1]);//Բյ㴴Բ
			//CurveVectorPtr cylinder4 = CurveVector::Create(CurveVector::BOUNDARY_TYPE_Outer);
			cylinder4->Add(ICurvePrimitive::CreateArc(arcPts1));	//һ
			
			pts3_1[0]=pts3_1[1];
			pts3_1[1].x=basePt.x+KouCaoB_Xlen/2;	
			seg2.Init(pts3_1[0],pts3_1[1] );
			cylinder4->Add(ICurvePrimitive::CreateLine(seg2) );// һֱ
			
			pts3_1[0].x=basePt.x+KouCaoB_Xlen/2;pts3_1[0].y=pts22[2].y;pts3_1[0].z=pts22[2].z;// 
			pts3_1[1].x=basePt.x+kouCaoT_XLen/2;pts3_1[1].y=pts2[2].y;pts3_1[1].z=pts11[2].z;//յ			
			CirPos.x=pts3_1[0].x+KC_R;CirPos.y=pts3_1[0].y;CirPos.z=pts3_1[0].z;
			arcPts1.InitFromCenterMajorAxisPointAndThirdPoint(CirPos, pts3_1[0], pts3_1[1]);//Բյ㴴Բ
			cylinder4->Add(ICurvePrimitive::CreateArc(arcPts1));	//ڶ
			
			/*
			pts3_1[0]=pts3_1[1];//ֱߵ
			pts3_1[1].x=basePt.x-kouCaoT_XLen/2;pts3_1[1].y=pts2[2].y;pts3_1[1].z=pts11[2].z;//ֱߵյ
			seg2.Init(pts3_1[0],pts3_1[1] );
			cylinder4->Add(ICurvePrimitive::CreateLine(seg2) );// ڶֱ
			*///zxl_add 2020-07-09 ע
			pts3_1[0]=pts3_1[1];//ֱߵ
			pts3_1[1].x=basePt.x+kouCaoT_XLen/2;pts3_1[1].y=pts2[2].y;pts3_1[1].z=basePt.z;//յ
			seg2.Init(pts3_1[0],pts3_1[1] );
			cylinder4->Add(ICurvePrimitive::CreateLine(seg2) );// ڶֱ
			
			pts3_1[0]=pts3_1[1];//ֱߵ
			pts3_1[1].x=basePt.x-kouCaoT_XLen/2;pts3_1[1].y=pts2[3].y;pts3_1[1].z=basePt.z;//ֱߵյ
			seg2.Init(pts3_1[0],pts3_1[1] );
			cylinder4->Add(ICurvePrimitive::CreateLine(seg2) );// ڶֱ
			
			DVec3d extrusionVec5 = DVec3d::From(0, -KouCaoDeepY, 0 );
			DgnExtrusionDetail  data5(cylinder4, extrusionVec5, true);//pCurveVec 
			ISolidPrimitivePtr pSolid5 = ISolidPrimitive::CreateDgnExtrusion(data5);	
			DraftingElementSchema::ToElement(kc_eeh2, *pSolid5, nullptr, *ACTIVEMODEL);//תάʵ塣
			kc_eeh2.AddToModel();kc_eeh1.AddToModel();
		}
		
		//߲ ׼׶Σ eehcylinder1 Ļһ eehcylinder2 Ļ  eehĳ  м㡣
		if (!eehRect.IsValid() || !eehcylinder1.IsValid() || !eehcylinder2.IsValid() || !eehQ1.IsValid() || !eehQ2.IsValid() || !kc_eeh1.IsValid() || !kc_eeh2.IsValid())
			return -3;
		ISolidKernelEntityPtr	upTarget, downTarget , downTarget2 , downTarget3 , downTarget4 , downTarget5 , downTarget6;
		
		if (SUCCESS != SolidUtil::Convert::ElementToBody(upTarget, eehRect, true, true, true))//
			return -4;
		if (SUCCESS != SolidUtil::Convert::ElementToBody(downTarget, eehcylinder1, true, true, true))//һ YZһ
			return -5;
		if (SUCCESS != SolidUtil::Convert::ElementToBody(downTarget2, eehcylinder2, true, true, true))//  YZһ
			return -6;
		if (SUCCESS != SolidUtil::Convert::ElementToBody(downTarget3, eehQ1, true, true, true))//  XZ ʵһ
			return -7;
		if (SUCCESS != SolidUtil::Convert::ElementToBody(downTarget4, eehQ2, true, true, true))// XZ ʵ
			return -8;
		if (SUCCESS != SolidUtil::Convert::ElementToBody(downTarget5, kc_eeh1, true, true, true))//  XZ ϵĿ۲һ
			return -9;
		if (SUCCESS != SolidUtil::Convert::ElementToBody(downTarget6, kc_eeh2, true, true, true))//  XZ ϵĿ۲۶
			return -10;
			
		bvector<ISolidKernelEntityPtr>tool;
		if (downTarget.IsValid() && upTarget.IsValid() )
			tool.push_back(downTarget);
		else
			return -11;
		//ڰ˲ʼ и㡣
		if (SUCCESS != SolidUtil::Modify::BooleanSubtract(upTarget, &tool.front(), tool.size() ) )//и ƿһ
			return -12;
		tool.clear();
		tool.push_back(downTarget2);
		if (SUCCESS != SolidUtil::Modify::BooleanSubtract(upTarget, &tool.front(), tool.size() ) )//и ƿ
			return -12;
		tool.clear();
		tool.push_back(downTarget3);
		if (SUCCESS != SolidUtil::Modify::BooleanSubtract(upTarget, &tool.front(), tool.size() ) )//иʵһ
			return -12;
		tool.clear();
		tool.push_back(downTarget4);
		if (SUCCESS != SolidUtil::Modify::BooleanSubtract(upTarget, &tool.front(), tool.size() ) )//иʵ
			return -12;
		tool.clear();
		tool.push_back(downTarget5);
		if (SUCCESS != SolidUtil::Modify::BooleanSubtract(upTarget, &tool.front(), tool.size() ) )//и XZ  ϵĵһ۲ۡ
			return -12;
		tool.clear();
		tool.push_back(downTarget6);
		if (SUCCESS != SolidUtil::Modify::BooleanSubtract(upTarget, &tool.front(), tool.size() ) )//и XZ  ϵĵڶ۲ۡ
			return -12;
		if (SUCCESS != SolidUtil::Convert::BodyToElement(eeh, *upTarget, &eehRect, *eehRect.GetModelRef() ) )//иĻƿ תʵ eeh4 .
				return -13;
		BT_Rect_ZLen=TotalZLen-TopRectZlen - HuZLen;
		return 0;
	}
private:
	
	void Prepare_Data(DPoint3dCR basePt)
	{
		//㼯ϣΪ塣
	pts1[0].x=basePt.x-TopRectXLen/2;pts1[0].y=basePt.y-TopRectYLen/2;pts1[0].z=basePt.z;
	pts1[1].x=basePt.x+TopRectXLen/2;pts1[1].y=basePt.y-TopRectYLen/2;pts1[1].z=basePt.z;
	pts1[2].x=basePt.x+TopRectXLen/2;pts1[2].y=basePt.y+TopRectYLen/2;pts1[2].z=basePt.z;
	pts1[3].x=basePt.x-TopRectXLen/2;pts1[3].y=basePt.y+TopRectYLen/2;pts1[3].z=basePt.z;

	pts11[0].x=basePt.x-TopRectXLen/2;pts11[0].y=basePt.y-TopRectYLen/2;pts11[0].z=basePt.z-TopRectZlen;
	pts11[1].x=basePt.x+TopRectXLen/2;pts11[1].y=basePt.y-TopRectYLen/2;pts11[1].z=basePt.z-TopRectZlen;
	pts11[2].x=basePt.x+TopRectXLen/2;pts11[2].y=basePt.y+TopRectYLen/2;pts11[2].z=basePt.z-TopRectZlen;
	pts11[3].x=basePt.x-TopRectXLen/2;pts11[3].y=basePt.y+TopRectYLen/2;pts11[3].z=basePt.z-TopRectZlen;
	//ε
	pts2[0].x=basePt.x-BT_Rect_XLen/2;pts2[0].y=basePt.y-BT_Rect_YLen/2;pts2[0].z=basePt.z-TotalZLen;
	pts2[1].x=basePt.x+BT_Rect_XLen/2;pts2[1].y=basePt.y-BT_Rect_YLen/2;pts2[1].z=basePt.z-TotalZLen;
	pts2[2].x=basePt.x+BT_Rect_XLen/2;pts2[2].y=basePt.y+BT_Rect_YLen/2;pts2[2].z=basePt.z-TotalZLen;
	pts2[3].x=basePt.x-BT_Rect_XLen/2;pts2[3].y=basePt.y+BT_Rect_YLen/2;pts2[3].z=basePt.z-TotalZLen;
	
	pts22[0].x=basePt.x-BT_Rect_XLen/2;pts22[0].y=basePt.y-BT_Rect_YLen/2;pts22[0].z=basePt.z-TotalZLen+BT_Rect_ZLen;
	pts22[1].x=basePt.x+BT_Rect_XLen/2;pts22[1].y=basePt.y-BT_Rect_YLen/2;pts22[1].z=basePt.z-TotalZLen+BT_Rect_ZLen;
	pts22[2].x=basePt.x+BT_Rect_XLen/2;pts22[2].y=basePt.y+BT_Rect_YLen/2;pts22[2].z=basePt.z-TotalZLen+BT_Rect_ZLen;
	pts22[3].x=basePt.x-BT_Rect_XLen/2;pts22[3].y=basePt.y+BT_Rect_YLen/2;pts22[3].z=basePt.z-TotalZLen+BT_Rect_ZLen;

	}
	
	double TotalZLen;//=7000;
	double HuZLen;//=2000;//߶ //߶뾶 ݣֻһΪ֪Ӷһ֪
	double HuR;//=2000;//뾶//߶뾶 ݣֻһΪ֪Ӷһ֪
	double TopRectXLen;//=3000,//ƿնεĳXߴϢ
	double TopRectYLen;//=2000,//ƿնεĿYߴϢ
	double TopRectZlen;//=500;// ƿնεĸߣZߴϢ
	
	int    nArcFlag;//ĬΪ-1Ϊ0ʱЧֵΪߣΪ1ʱЧֵΪİ뾶ƿյϢ
	int    nKC;//ĬΪ-1Ϊ0ʱ ЧֵΪ۲ۻߣΪ1ʱ ЧֵΪ۲ۻİ뾶
	
	double H2;//=0; ƿ ڲ ǻο۲ۣθߣΪ0ο۲۴ӻƿնʼ۲ۣ۲ʾο۲ۣȻǻο۲ۡ
	double kouCaoT_XLen;//=750,
	double KouCaoB_Xlen;//=450,
	double KouCaoDeepY;//=150,
	double KouCaoHuZlen;//=2000;//۲ָݡ
	double KC_R;//=(0.25*(kouCaoT_XLen - KouCaoB_Xlen)*(kouCaoT_XLen - KouCaoB_Xlen) + KouCaoHuZlen*KouCaoHuZlen) / (kouCaoT_XLen - KouCaoB_Xlen);
	
	int nKCFlag;//۲ ر־0 رտ۲  1۲ۡ
	DPoint3d         pts1[4];
	DPoint3d         pts11[4];	
	DPoint3d         pts2[4];
	DPoint3d         pts22[4];
public:
	
	double BT_Rect_XLen;//=2000,//ƿյײεĳXߴϢ
	double BT_Rect_YLen;//=1500;//ƿյײεĿYߴϢ
	double BT_Rect_ZLen;//=TotalZLen-TopRectZlen - HuZLen;//ƿյײεĸߣZߴϢҪȡ
};
#endif